#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

#define BUG
#define LINESIZE 256
#define FALSE 0
#define TRUE 1

FILE *in;
long nb = 10;
int charmode = FALSE;
int keeplast = TRUE;

void charnofirst()
{
    int c;

    while (--nb > 0 && getc(in) != EOF) ;

    while ((c = getc(in)) != EOF && putchar(c) != EOF) ;
}

void linenofirst()
{
    char buf[LINESIZE + 1]; /* Ensure NULL byte at end ... */

    while (--nb > 0 && fgets(buf, LINESIZE, in)) ;

    while (fgets(buf, LINESIZE, in) && fputs(buf, stdout) == 0) ;
}

void charlast()
{
    char *buf;
    int buffull;
    long readsize;

    buf = malloc(nb);
    if (!buf)
    {
        fputs("No memory !\n", stderr);
        exit(10);
    }

    buffull = FALSE;

    while ((readsize = fread(buf, 1, nb, in)) == nb) buffull = TRUE;

    if (buffull) if (!fwrite(buf + readsize, nb - readsize, 1, stdout)) return;
     
    fwrite(buf, readsize, 1, stdout);
}

void linelast()
{
    typedef char LINEBUF[LINESIZE + 1];
    LINEBUF *buf, *bufpos, *bufend, *scanbuf;
    int buffull;

#ifdef BUG
    nb++;
#endif

    buf = (LINEBUF *)malloc(nb * (LINESIZE + 1));
    if (!buf)
    {
        fputs("No memory !\n", stderr);
        exit(10);
    }

    bufend = buf + nb;
    bufpos = buf; buffull = FALSE;

    while (fgets(*bufpos, LINESIZE, in))
    {
        bufpos++;
        if (bufpos == bufend)
        {
            bufpos = buf;
            buffull = TRUE;
        }
    }


    if (buffull)
       for (scanbuf = bufpos; scanbuf != bufend; scanbuf++)
            if (fputs(*scanbuf, stdout) != 0) return;

    for (scanbuf = buf; scanbuf != bufpos; scanbuf++)
        if (fputs(*scanbuf, stdout) != 0) return;
}

/*
 +nb<l/c>
 -nb<l/c>
 -l/c
*/

int analyse_opts(opt)
char *opt;
{
    if (opt[0] != '+' && opt[0] != '-') return(FALSE);

    if (opt[0] == '+')
    {
        int l;

        l = stcd_l(++opt, &nb);
        if (l == 0) return(FALSE);
        opt += l;
        keeplast = FALSE;
    }
    else
        if (isdigit(*++opt)) opt += stcd_l(opt, &nb);

    if (opt[0] == 'l') opt++;
    else if (opt[0] == 'c') { charmode = TRUE; opt++; }

    return(opt[0] == '\0');
}

void main(argc, argv)
int argc;
char **argv;
{
    int usage = TRUE;

    if (argc == 1)
    {
        in = stdin;
        usage = TRUE;
    }
    else if (argc == 2)
    {
        in = stdin;
        usage = analyse_opts(argv[1]);
    }
    else if (argc == 3)
    {
        if (usage = analyse_opts(argv[1]))
        {
            in = fopen(argv[2], "r");
            if (!in)
            {
                fputs("Couldn't open file\n", stderr);
                exit(10);
            }
        }
    }
    else usage = FALSE;

    if (!usage)
        fputs("Usage: tail [+/-number][l/c] [file]\n", stderr);
    else
    {
        if (charmode)
            if (keeplast)
                charlast();
            else
                charnofirst();
        else
            if (keeplast)
                linelast();
            else
                linenofirst();
    }
}

